package com.zhengyiyu.feature;

import java.util.ArrayList;

public abstract class SequenceFeature {

	private String featureName;
	
	private String reference;
	
	private String patternName; // such as A, B, C, D
	
	// there are there norns for pattern, patternName = A, patternIndex = 1, patternLabel = A1
	
	// each feature have 4 group...
	// so need 3 cutoff, but the cutoff number should be flexible
	// and we should have some connection with the original feature, or maybe just used to generate the data, and do not care about it anymore
	// because later we need to use this class to calculate other's so still need to design it carefully.
	// need to consider repeat mask.
	private ArrayList<Double> discretizationCutoff;
	
	public SequenceFeature() {
		super();
		this.discretizationCutoff = new ArrayList<Double>();
	}

	/**
	 * @param value the feature value
	 * @return the corresponding discretized level
 	 */
	public String getPatternLabel(double value) {
		return patternName + getPatternIndex(value);
	}
	
	/**
	 * @param value the feature value
	 * @return the corresponding discretized level
 	 */
	public int getPatternIndex(double value) {
		int i = 0;
		for (; i < discretizationCutoff.size(); i++) {
			if (value < discretizationCutoff.get(i)) {
				break;
			}
		}
		return i;
	}
	
	/**
	 * @return the attrName
	 */
	public String getFeatureName() {
		return featureName;
	}

	/**
	 * @param attrName the attrName to set
	 */
	public void setFeatureName(String attrName) {
		this.featureName = attrName;
	}

	public abstract double calculateFeatureValue(String sequence);

	/**
	 * @return the patternName
	 */
	public String getPatternName() {
		return patternName;
	}

	/**
	 * @param patternName the patternName to set
	 */
	public void setPatternName(String patternName) {
		this.patternName = patternName;
	}

	/**
	 * @return the discretizationCutoff
	 */
	public ArrayList<Double> getDiscretizationCutoff() {
		return discretizationCutoff;
	}

	/**
	 * @param discretizationCutoff the discretizationCutoff to set
	 */
	public void setDiscretizationCutoff(ArrayList<Double> discretizationCutoff) {
		this.discretizationCutoff = discretizationCutoff;
	}

	/**
	 * @return the reference
	 */
	public String getReference() {
		return reference;
	}

	/**
	 * @param reference the reference to set
	 */
	public void setReference(String reference) {
		this.reference = reference;
	}

	/**
	 * @return the level list of all the discretization
	 */
	public String getDiscretizationDetail() {
		String s = "";
		for (Double d : discretizationCutoff) {
			s = s + d + ",";
		}
		return s;
	}
}
