package com.zhengyiyu.handler;

import com.zhengyiyu.obj.Sequence;

/**
 * @author Yiyu
 * interface for sequence reader of all species,
 * currently we have human and yeast
 */
public interface SequenceReader {
	/**
	 * @param chrName
	 * @param startPosition
	 * @param length
	 * @return the DNA sequence of the position from the startPosition
	 */
	String getSequenceByLength(String chrName, int startPosition, int length);
	
	String getSequenceBySE(String chrName, int startPosition, int endPosition);
	
	String getSequence(Sequence seq);
	/**
	 * @param chrName
	 * @return the length of the chromosome, usually it is stored in the class directly
	 */
	int getChromosomeLength(String chrName);
}
