package com.zhengyiyu.obj;

import java.util.ArrayList;

import com.zhengyiyu.util.DoubleUtil;

public class Transcript extends Sequence {

	private String transcriptId;
	private String name;
	private String type;
	
	private ArrayList<Double> exps;
	
	public Transcript(String chromosome, int startPosition, int endPosition) {
		super(chromosome, startPosition, endPosition);
		this.exps = new ArrayList<Double>();
	}

	/**
	 * @return the transcriptId
	 */
	public String getTranscriptId() {
		return transcriptId;
	}

	/**
	 * @param transcriptId the transcriptId to set
	 */
	public void setTranscriptId(String transcriptId) {
		this.transcriptId = transcriptId;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type the type to set
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return the exps
	 */
	public ArrayList<Double> getExps() {
		return exps;
	}

	/**
	 * @param exps the exps to set
	 */
	public void setExps(ArrayList<Double> exps) {
		this.exps = exps;
	}

	public String toString(ArrayList<String> status) {
		StringBuffer sb = new StringBuffer();
		sb.append(this.name);
		sb.append("\t" + super.toString());
		sb.append("\t" + this.type);
		
		sb.append("\t[");
		for (int i = 0; i < status.size(); i++) {
			if (i > 0) {
				sb.append(", ");
			}
			sb.append(status.get(i) + ":" + DoubleUtil.df3.format(exps.get(i)));
		}
		sb.append("]");
		return sb.toString();
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(this.name);
		
		sb.append("\t" + super.toString());
		sb.append("\t" + this.type);
		sb.append("\t" + this.transcriptId);
		sb.append("\t[");
		for (int i = 0; i < exps.size(); i++) {
			if (i > 0) {
				sb.append(", ");
			}
			sb.append(DoubleUtil.df3.format(exps.get(i)));
		}
		sb.append("]");
		return sb.toString();
	}
	
	public String toTSString() {
		StringBuffer sb = new StringBuffer();
		if (this.type != null) {
			sb.append(this.type + "\t");
		}
		sb.append(this.transcriptId);
		sb.append("\t" + toGeneExpressionString());
		return sb.toString();
	}
	
	/**
	 * @return the gene expression data of the transcript
	 */
	public String toGeneExpressionString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < exps.size(); i++) {
			if (i > 0) {
				sb.append(", ");
			}
			sb.append(DoubleUtil.df3.format(exps.get(i)));
		}
		sb.append("]");
		return sb.toString();
	}
	
	/**
	 * @return the gene expression data of the transcript separated by TAB
	 */
	public String toTabGeneExpressionString() {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < exps.size(); i++) {
			if (i > 0) {
				sb.append("\t");
			}
			sb.append(DoubleUtil.df3.format(exps.get(i)));
		}
		return sb.toString();
	}

}
